#ifndef _RECEIVER_H
#define _RECEIVER_H

#define FIR_BUF_SIZE 64
#define FIR_BUF_INDEX(x) ((x) & (FIR_BUF_SIZE - 1))

struct _FIR
{
  int   idx;                   /* pointer to current sample */
  int   order;                 /* filter order */
  long  *weights;              /* filter coefficients */
  short buf[FIR_BUF_SIZE];     /* FIR delay buffer */
};

short FIR_process(struct _FIR *fir, short input);

struct _receiver
{
  struct _transmitter *tx;
  char                remote_id[7];
  int           status,       /* receiver status */
                frm_cnt,      /* frame counter */
                bit_num,      /* current bit number */
                bit_cnt,      /* word bit counter */
                word_cnt,     /* word counter */
                tty_len;
  unsigned long stream;       /* receiver bitstream */
  unsigned char data[12],     /* buffer for received frame */
                tty_buf[32],
                nrx;
  /* demodulator stuff */
  struct _FIR   fir;            /* input receive filter */
  short         os;             /* old sample */
  int           timer,
                no_carrier,
                monostable[64], /* 64 bytes for monostable circle delay buffer will 
                                 * be enougth even for 44100 sample rate */
                disc[64],       /* size of that array depends on FILTER_ORDER, and in
                                 * our case can be 16, but let it be 64, just in case */
                ci,
                pll,
                disc_FIR,
                counter,
                old_data;
};

int rx_init(struct _receiver *rx, struct _transmitter *tx);
int rx_decode(struct _receiver *rx, short *buf, int size);

#endif