#ifndef _TRANSMITTER_H
#define _TRANSMITTER_H

struct _transmitter
{
  int           bit_num,      /* current bit number */
                bit_cnt,      /* word bit counter */
                word_cnt,     /* word counter */
                frm_cnt,      /* frame counter */
                frm_len,      /* frame length */
                hold,         /* hold timer for NR */
                delay,        /* delay timer for RR delay */
                wif,          /* words in frame - depends on 7 or 8 bit mode */
                tty_len,      /* input buffer length */
                queue_len,    /* length of queue */
                queue_idx,    /* index of last unfilled word of frame in queue */
                control_flag; /* flag is set if we have control frame to send */
  unsigned char data[12],     /* words to transmit */
                queue[4][12], /* transmitter frames queue */
                control[8],   /* control frame */
                tty_buf[32],  /* input data buffer */
                stream,       /* transmitter bitstream */
                dt_label,     /* received DT frame label */
                rr_label,     /* received RR/NR frame label */
                dir,          /* direction bit */
                ntx,          /* NTX */
                n;            /* internal frame counter */
/* modulator stuff */
  int           si,           /* counter */
                current_bit,  /* currently transmitting bit */
                phase;        /* phase */
  short         sin_lo[BAUD_TIME],  /* 1200 Hz sine table */
                sin_hi[BAUD_TIME];  /* 1800 Hz sine table */
};

int tx_init(struct _transmitter *tx);
int tx_encode(struct _transmitter *tx, short *buf, int size);
unsigned short get_checksum(unsigned char *data);

#endif